
// Mecanismo 1View.cpp: implementacin de la clase CMecanismo1View
//

#include "stdafx.h"
// Se pueden definir SHARED_HANDLERS en un proyecto ATL implementando controladores de vista previa, miniatura
// y filtro de bsqueda, y permiten compartir cdigo de documentos con ese proyecto.
#ifndef SHARED_HANDLERS
#include "Mecanismo 1.h"
#endif

#include "Mecanismo 1Doc.h"
#include "Mecanismo 1View.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMecanismo1View

IMPLEMENT_DYNCREATE(CMecanismo1View, CView)

BEGIN_MESSAGE_MAP(CMecanismo1View, CView)
	// Comandos de impresin estndar
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_INICIALIZAR, OnInitial)
	ON_COMMAND(ID_CAPTURAR, OnCapturar)
	ON_COMMAND(ID_SIMULAR, OnSimular)
	ON_COMMAND(ID_OPCIONES_COLOR, OnColor)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()

	
	
	ON_COMMAND(ID_UNIR, &CMecanismo1View::OnUnir)
END_MESSAGE_MAP()

// Construccin o destruccin de CMecanismo1View

CMecanismo1View::CMecanismo1View()
{
	m_State = CMD_DEMO;
	m_NumPoint = 0;

}

CMecanismo1View::~CMecanismo1View()
{
	if ( IsWindow(m_hWnd) ) KillTimer(1313);
}

BOOL CMecanismo1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: modificar aqu la clase Window o los estilos cambiando
	//  CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// Impresin de CMecanismo1View

BOOL CMecanismo1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Preparacin predeterminada
	return DoPreparePrinting(pInfo);
}

void CMecanismo1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: agregar inicializacin adicional antes de imprimir
}

void CMecanismo1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: agregar limpieza despus de imprimir
}


// Diagnsticos de CMecanismo1View

#ifdef _DEBUG
void CMecanismo1View::AssertValid() const
{
	CView::AssertValid();
}

void CMecanismo1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMecanismo1Doc* CMecanismo1View::GetDocument() const // La versin de no depuracin es en lnea
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMecanismo1Doc)));
	return (CMecanismo1Doc*)m_pDocument;
}
#endif //_DEBUG


int CMecanismo1View::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetTimer(1313,10,NULL);    

}

/***********************************************************************************************************************/
void CMecanismo1View::OnTimer(UINT nIDEvent) 
{
	if ( nIDEvent == 1313 )
	 {

		CMecanismo1Doc * pDoc = GetDocument();
		pDoc->m_dAngle1 += 1/57.295;
		pDoc->m_dAngle2 += 2/57.295;
		pDoc->m_dAngle3 += 1.0/57.295;
		if (pDoc->m_dAngle1 > 360.0/57.295 ) pDoc->m_dAngle1 = 0.0;
		if (pDoc->m_dAngle2 > 360.0/57.295 ) pDoc->m_dAngle2 = 0.0;
		if (pDoc->m_dAngle3 > 360/57.295 ) pDoc->m_dAngle3 = 0.0;

		InvalidateRect(NULL);
	 }
}

/***********************************************************************************************************************/
void CMecanismo1View::SetMapping(CDC * pDC) 
{
	pDC->SetMapMode(MM_ISOTROPIC);
	CRect rcCli;
	GetClientRect(rcCli);
	pDC->SetWindowOrg(0,rcCli.bottom);
	pDC->SetWindowExt(rcCli.Width(),-800);
	pDC->SetViewportOrg(0,0);
	pDC->SetViewportExt(rcCli.Width(),rcCli.Height());
}

/***********************************************************************************************************************/
// Dibujo de CMecanismo1View

void CMecanismo1View::OnDraw(CDC* pDC)
{
	CMecanismo1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	SetMapping(pDC); 

	if ( m_State == CMD_DEMO ) 	TraceNodeDemo(pDC);
	else if ( m_State == CMD_CAPTURA ) 	TraceNodeCapture(pDC);
	else if ( m_State == CMD_SIMULA ) 	TraceNodeSimula(pDC);
	
	// Tierra
	CBrush DashBrush;
	DashBrush.CreateHatchBrush(HS_BDIAGONAL,0);
	pDC->SelectStockObject(BLACK_PEN); 
	pDC->Ellipse(pDoc->m_ptNode1.m_X-5,pDoc->m_ptNode1.m_Y-5,pDoc->m_ptNode1.m_X+5,pDoc->m_ptNode1.m_Y+5);
	pDC->Ellipse(pDoc->m_ptNode4.m_X-5,pDoc->m_ptNode4.m_Y-5,pDoc->m_ptNode4.m_X+5,pDoc->m_ptNode4.m_Y+5);
	pDC->SelectObject(DashBrush);
	pDC->Rectangle(pDoc->m_ptNode1.m_X-50,pDoc->m_ptNode1.m_Y,pDoc->m_ptNode4.m_X+50,pDoc->m_ptNode4.m_Y-20);

}
/***********************************************************************************************************************/

void CMecanismo1View::TraceNodeDemo(CDC* pDC)
{
	CMecanismo1Doc * pDoc = GetDocument();
	CPen DotPen(PS_DOT,0,RGB(255,0,0));

	CRect rcCli;
	GetClientRect(rcCli);

// Elabon 1 
	pDoc->m_ptNode2.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*cos(pDoc->m_dAngle1);
	pDoc->m_ptNode2.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*sin(pDoc->m_dAngle1);
	TraceEslabon(pDC,pDoc->m_ptNode1,pDoc->m_ptNode2,pDoc->m_nEslabon1,RGB(255,0,0));

// Eslabon 2 
	pDoc->m_ptNode3.m_X = pDoc->m_ptNode2.m_X + pDoc->m_nEslabon2*cos(pDoc->m_dAngle2);
	pDoc->m_ptNode3.m_Y = pDoc->m_ptNode2.m_Y + pDoc->m_nEslabon2*sin(pDoc->m_dAngle2);
	TraceEslabon(pDC,pDoc->m_ptNode2,pDoc->m_ptNode3,pDoc->m_nEslabon2,RGB(0,255,0));

//	CalcPoints(pDoc->m_ptNode2,pDoc->m_nEslabon2,pDoc->m_ptNode4,pDoc->m_nEslabon3);

// Eslabon 3 
  	  pDoc->m_ptNode3.m_X = pDoc->m_ptNode4.m_X + pDoc->m_nEslabon3*cos(pDoc->m_dAngle3);
	  pDoc->m_ptNode3.m_Y = pDoc->m_ptNode4.m_Y + pDoc->m_nEslabon3*sin(pDoc->m_dAngle3);
	  TraceEslabon(pDC,pDoc->m_ptNode4,pDoc->m_ptNode3,pDoc->m_nEslabon3,RGB(0,0,255));
}
/***********************************************************************************************************************/
void CMecanismo1View::OnMouseMove( UINT, CPoint PtMouse)
{
	CMecanismo1Doc * pDoc = GetDocument();
	CDC * pDC = GetDC();
  	SetMapping(pDC); 
	CPen DotPen(PS_DOT,0,RGB(255,0,0));
	CRect rcCli;
	GetClientRect(rcCli);
	pDC->DPtoLP(&PtMouse);

	if ( m_State == CMD_CAPTURA && m_NumPoint < 4)
	 {
	  if ( m_NumPoint == 0 )
	   {

// Elabon 1 
		pDoc->m_nEslabon1 = sqrt((double)(PtMouse.x - pDoc->m_ptNode1.m_X)*(PtMouse.x - pDoc->m_ptNode1.m_X) +
							             (PtMouse.y - pDoc->m_ptNode1.m_Y)*(PtMouse.y - pDoc->m_ptNode1.m_Y));
		pDoc->m_ptNode2.m_X = PtMouse.x;
		pDoc->m_ptNode2.m_Y = PtMouse.y;
	   }
	  else if ( m_NumPoint == 1 )
	   {
// Elabon 2 
		pDoc->m_nEslabon3 = sqrt((double)(PtMouse.x - pDoc->m_ptNode4.m_X)*(PtMouse.x - pDoc->m_ptNode4.m_X) +
							             (PtMouse.y - pDoc->m_ptNode4.m_Y)*(PtMouse.y - pDoc->m_ptNode4.m_Y));
		pDoc->m_ptNode3.m_X = PtMouse.x;
		pDoc->m_ptNode3.m_Y = PtMouse.y;
	   }	 }
   ReleaseDC(pDC);

}

/***********************************************************************************************************************/
void CMecanismo1View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if ( m_State == CMD_CAPTURA && m_NumPoint < 4)
	{
	 CMecanismo1Doc * pDoc = GetDocument();
	 CDC * pDC = GetDC();
	 SetMapping(pDC); 
	 pDC->DPtoLP(&point);
	 m_NumPoint++;
	 if ( m_NumPoint == 1 ) 
	  {
       pDoc->m_ptNode2.m_X = point.x;
       pDoc->m_ptNode2.m_Y = point.y;
	   pDoc->m_nEslabon1 = sqrt((double)(pDoc->m_ptNode2.m_X - pDoc->m_ptNode1.m_X)*(pDoc->m_ptNode2.m_X - pDoc->m_ptNode1.m_X) +
						        (pDoc->m_ptNode2.m_Y - pDoc->m_ptNode1.m_Y)*(pDoc->m_ptNode2.m_Y - pDoc->m_ptNode1.m_Y));
// Decoracion
	   pDoc->m_ptNode3 = pDoc->m_ptNode2;
	   InvalidateRect(NULL);
	   }
	 else if ( m_NumPoint == 2 ) 
	   {	 
       pDoc->m_ptNode3.m_X = point.x;
       pDoc->m_ptNode3.m_Y = point.y;// initial state
	   pDoc->m_nEslabon3 = sqrt((double)(pDoc->m_ptNode3.m_X - pDoc->m_ptNode4.m_X)*(pDoc->m_ptNode3.m_X - pDoc->m_ptNode4.m_X) +
						                (pDoc->m_ptNode3.m_Y - pDoc->m_ptNode4.m_Y)*(pDoc->m_ptNode3.m_Y - pDoc->m_ptNode4.m_Y));
//	   pDoc->m_dAngle3 = (pDoc->m_ptNode3.m_Y - pDoc->m_ptNode4.m_Y)/(pDoc->m_ptNode3.m_X - pDoc->m_ptNode4.m_X);
	  }
	 else if ( m_NumPoint == 3 ) 
	  {
	   double dDiag = sqrt((double)(point.x-pDoc->m_ptNode1.m_X)*(point.x-pDoc->m_ptNode1.m_X) + (point.y-pDoc->m_ptNode1.m_Y)*(point.y-pDoc->m_ptNode1.m_Y));
	   pDoc->m_ptNode2.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*(point.x-pDoc->m_ptNode1.m_X)/dDiag;
	   pDoc->m_ptNode2.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*(point.y-pDoc->m_ptNode1.m_Y)/dDiag;
	 }
	 else if ( m_NumPoint == 4 ) 
	  {
	   double dDiag = sqrt((double)(point.x-pDoc->m_ptNode4.m_X)*(point.x-pDoc->m_ptNode4.m_X) + (point.y-pDoc->m_ptNode4.m_Y)*(point.y-pDoc->m_ptNode4.m_Y));
	   m_PtLastPoint.m_X = pDoc->m_ptNode4.m_X + pDoc->m_nEslabon3*(point.x-pDoc->m_ptNode4.m_X)/dDiag;
	   m_PtLastPoint.m_Y = pDoc->m_ptNode4.m_Y + pDoc->m_nEslabon3*(point.y-pDoc->m_ptNode4.m_Y)/dDiag;
	   pDoc->m_nEslabon2 = sqrt((double)(pDoc->m_ptNode3.m_X - pDoc->m_ptNode2.m_X)*(pDoc->m_ptNode3.m_X - pDoc->m_ptNode2.m_X) +
						                (pDoc->m_ptNode3.m_Y - pDoc->m_ptNode2.m_Y)*(pDoc->m_ptNode3.m_Y - pDoc->m_ptNode2.m_Y));
	   m_State = CMD_SIMULA;
	   m_NumPoint = 0;
	   pDoc->m_ptNode3.m_X = m_PtLastPoint.m_X;
	   pDoc->m_ptNode3.m_Y = m_PtLastPoint.m_Y;
	 }
	 ReleaseDC(pDC);
	}
}

/***********************************************************************************************************************/
void CMecanismo1View::TraceNodeCapture(CDC* pDC)
{
	CMecanismo1Doc * pDoc = GetDocument();
	CPen DotPen(PS_DOT,0,RGB(255,0,0));
	FPOINT PtNodeMoving;
	CRect rcCli;
	GetClientRect(rcCli);

// Elabon 1 	
	if ( m_NumPoint == 0 ) 
	{
	TraceEslabon(pDC,pDoc->m_ptNode1,pDoc->m_ptNode2,pDoc->m_nEslabon1,RGB(255,0,0));
	}
	else if ( m_NumPoint == 1 ) 
	 {
	  PtNodeMoving.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*cos(pDoc->m_dAngle1);
	  PtNodeMoving.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*sin(pDoc->m_dAngle1);
	  TraceEslabon(pDC,pDoc->m_ptNode1,PtNodeMoving,pDoc->m_nEslabon1,RGB(255,0,0));
	  TraceEslabon(pDC,pDoc->m_ptNode4,pDoc->m_ptNode3,pDoc->m_nEslabon3,RGB(255,0,0));
	 }
	else if (m_NumPoint == 2)
	 {
	  PtNodeMoving.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*cos(pDoc->m_dAngle1);
	  PtNodeMoving.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*sin(pDoc->m_dAngle1);
	  TraceEslabon(pDC,pDoc->m_ptNode1,PtNodeMoving,pDoc->m_nEslabon1,RGB(255,0,0));
	  PtNodeMoving.m_X = pDoc->m_ptNode4.m_X + pDoc->m_nEslabon3*cos(pDoc->m_dAngle3);
	  PtNodeMoving.m_Y = pDoc->m_ptNode4.m_Y + pDoc->m_nEslabon3*sin(pDoc->m_dAngle3);
	  TraceEslabon(pDC,pDoc->m_ptNode4,PtNodeMoving,pDoc->m_nEslabon3,RGB(0,0,255));
	 }	
	else if ( m_NumPoint == 3) 
	 {
	  PtNodeMoving.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*cos(pDoc->m_dAngle1);
	  PtNodeMoving.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*sin(pDoc->m_dAngle1);
	  TraceEslabon(pDC,pDoc->m_ptNode1,pDoc->m_ptNode2,pDoc->m_nEslabon1,RGB(255,0,0));
	  PtNodeMoving.m_X = pDoc->m_ptNode4.m_X + pDoc->m_nEslabon3*cos(pDoc->m_dAngle3);
	  PtNodeMoving.m_Y = pDoc->m_ptNode4.m_Y + pDoc->m_nEslabon3*sin(pDoc->m_dAngle3);
	  TraceEslabon(pDC,pDoc->m_ptNode4,PtNodeMoving,pDoc->m_nEslabon3,RGB(0,0,255));
	}
/*
	// Eslabon 3 
	if ( m_NumPoint > 1 ) 
	 {
  	  PtNodeMoving.m_X = pDoc->m_ptNode4.m_X + pDoc->m_nEslabon3*cos(pDoc->m_nAngle3/57.295);
	  PtNodeMoving.m_Y = pDoc->m_ptNode4.m_Y + pDoc->m_nEslabon3*sin(pDoc->m_nAngle3/57.295);
	  TraceEslabon(pDC,pDoc->m_ptNode4,PtNodeMoving,pDoc->m_nEslabon3,RGB(0,0,255));
	 }
*/

// Eslabon 2 
	if ( m_NumPoint == 3 ) 
	 {
	  CDC * pDC = GetDC();
	  SetMapping(pDC); 
	  CPoint PtCursoPos;
	  GetCursorPos(&PtCursoPos);
	  ScreenToClient(&PtCursoPos);
	  pDC->DPtoLP(&PtCursoPos);
	  PtNodeMoving.m_X = PtCursoPos.x;
	  PtNodeMoving.m_Y = PtCursoPos.y;

	  int nEslabon = sqrt((double)(pDoc->m_ptNode2.m_X-PtNodeMoving.m_X)*(pDoc->m_ptNode2.m_X-PtNodeMoving.m_X) + 
								  (pDoc->m_ptNode2.m_Y-PtNodeMoving.m_Y)*(pDoc->m_ptNode2.m_Y-PtNodeMoving.m_Y));
	  pDC->Ellipse(pDoc->m_ptNode2.m_X-5,pDoc->m_ptNode2.m_Y-5,pDoc->m_ptNode2.m_X+5,pDoc->m_ptNode2.m_Y+5);
	  TraceEslabon(pDC,pDoc->m_ptNode2,PtNodeMoving,nEslabon,RGB(0,0,255));
	  ReleaseDC(pDC); 
	}

}


/***********************************************************************************************************************/

void CMecanismo1View::TraceNodeSimula(CDC* pDC)
{
	CMecanismo1Doc * pDoc = GetDocument();
	CPen DotPen(PS_DOT,0,RGB(255,0,0));

	CRect rcCli;
	GetClientRect(rcCli);

// Elabon 1 
	  pDoc->m_ptNode2.m_X = pDoc->m_ptNode1.m_X + pDoc->m_nEslabon1*cos(pDoc->m_dAngle1);
	  pDoc->m_ptNode2.m_Y = pDoc->m_ptNode1.m_Y + pDoc->m_nEslabon1*sin(pDoc->m_dAngle1);
	  TraceEslabon(pDC,pDoc->m_ptNode1,pDoc->m_ptNode2,pDoc->m_nEslabon1,RGB(255,0,0));

	  BOOL bResult = CalcPoints(pDoc->m_ptNode2,pDoc->m_nEslabon2,pDoc->m_ptNode4,pDoc->m_nEslabon3);
	  pDoc->m_ptNode3.m_X = m_PtLastPoint.m_X;
	  pDoc->m_ptNode3.m_Y = m_PtLastPoint.m_Y;

// Eslabon 2 
	   TraceEslabon(pDC,pDoc->m_ptNode2,pDoc->m_ptNode3,pDoc->m_nEslabon2,RGB(0,255,0));

//	if ( m_State == CMD_DEMO || (m_State == CMD_CAPTURA && m_NumPoint == 2) ) 
	   {
// Eslabon 3 
	    TraceEslabon(pDC,pDoc->m_ptNode4,pDoc->m_ptNode3,pDoc->m_nEslabon3,RGB(0,0,255));
	   }
/*
	if ( m_State == CMD_SIMULA )
	{
	  CalcPoints(pDoc->m_ptNode2,pDoc->m_nEslabon2,pDoc->m_ptNode4,pDoc->m_nEslabon3);

	}
*/
}

/***********************************************************************************************************************/

/***********************************************************************************************************************/
void CMecanismo1View::TraceEslabon(CDC * pDC, FPOINT & PtOrig,FPOINT & PtDest,int nSize,COLORREF rgbColor) 
{
	CPen DotPen(PS_DOT,0,rgbColor);

	pDC->SelectStockObject(BLACK_PEN); 
	pDC->MoveTo(PtOrig.m_X,PtOrig.m_Y);
	pDC->LineTo(PtDest.m_X,PtDest.m_Y);
	pDC->Ellipse(PtDest.m_X-5,PtDest.m_Y-5,PtDest.m_X+5,PtDest.m_Y+5);
	CPen * pOldPen = (CPen*)pDC->SelectObject(DotPen);
	pDC->SelectStockObject(NULL_BRUSH);
	pDC->Ellipse(PtOrig.m_X-nSize,PtOrig.m_Y-nSize,PtOrig.m_X+nSize,PtOrig.m_Y+nSize);
}
/***********************************************************************************************************************/
void CMecanismo1View::OnInitial()
{
	m_State = CMD_DEMO;
	m_NumPoint = 0 ; 
	CMecanismo1Doc * pDoc = GetDocument();
	pDoc->Initialize();

}
/***********************************************************************************************************************/

void CMecanismo1View::OnCapturar()
{
	m_State = CMD_CAPTURA;
	m_NumPoint = 0 ; 

}
/***********************************************************************************************************************/

void CMecanismo1View::OnSimular()
{
	m_State = CMD_SIMULA;
}
/***********************************************************************************************************************/

void CMecanismo1View::OnUnir()
{
	m_State = CMD_UNIR;	
}
/***********************************************************************************************************************/

void CMecanismo1View::OnColor()
{
	CColorDialog MyDlgColor;
	MyDlgColor.DoModal();
}

/***********************************************************************************************************************/

/***********************************************************************************************************************/

BOOL CMecanismo1View::CalcPoints(FPOINT PtCenter1,int nRadio1,FPOINT PtCenter2,int nRadio2) 
{
//	if ( (nRadio1 + nRadio2)*(nRadio1 + nRadio2) < (PtCenter1.m_X*PtCenter1.m_X)*(PtCenter1.m_X*PtCenter1.m_X) +
//							                     (PtCenter1.m_Y*PtCenter1.m_Y)*(PtCenter1.m_Y*PtCenter1.m_Y) ) return FALSE;
	CMecanismo1Doc * pDoc = GetDocument();
	CDC * pDC = GetDC();
	SetMapping(pDC); 

	double H1 = PtCenter1.m_X;
	double K1 = PtCenter1.m_Y;
	double H2 = PtCenter2.m_X;
	double K2 = PtCenter2.m_Y;

	double nM1 = (double)(PtCenter2.m_Y - PtCenter1.m_Y) / (double)(PtCenter2.m_X - PtCenter1.m_X);

	double nD1 = -2*H1;
	double nE1 = -2*K1;
	double nF1 = H1*H1 + K1*K1 - nRadio1*nRadio1;
	
	double nD2 = -2*H2;
	double nE2 = -2*K2;
	double nF2 = H2*H2 + K2*K2 - nRadio2*nRadio2;

	double A = nD1 - nD2;		// Ax + By + C = 0   Eje Radical
	double B = nE1 - nE2;
	double C = nF1 - nF2;

	double PtCenterEjeRadicalx = ( nM1*H1 - K1 - ((nF1 - nF2)/(nE1 -nE2)) ) / ( nM1 + ((nD1-nD2)/(nE1-nE2)) );
	double PtCenterEjeRadicaly = nM1*(PtCenterEjeRadicalx - H1) + K1;
/*
	pDC->SelectStockObject(NULL_BRUSH);
	pDC->Ellipse(PtCenterEjeRadicalx-5,PtCenterEjeRadicaly+5,PtCenterEjeRadicalx+5,PtCenterEjeRadicaly-5);
*/
	double DistaPointEje = (A*PtCenter1.m_X + B*PtCenter1.m_Y + C) / sqrt(A*A + B*B);
	double dDistCP = sqrt((nRadio1*nRadio1)-(DistaPointEje*DistaPointEje));

	double dTgTeta = -(nD1-nD2)/(nE1-nE2);
	double dTeta = atan(dTgTeta);
	double nDelta_x = dDistCP * cos(dTeta);
	double nDelta_y = dDistCP * sin(dTeta);

	FPOINT PtInter1,PtInter2;
	PtInter1.m_X = PtCenterEjeRadicalx + nDelta_x;
	PtInter1.m_Y = (-(nF1-nF2) - PtInter1.m_X * (nD1-nD2)) /(nE1-nE2);
	PtInter2.m_X = PtCenterEjeRadicalx - nDelta_x;
	PtInter2.m_Y = (-(nF1-nF2) - PtInter2.m_X * (nD1-nD2)) /(nE1-nE2);
/*
	pDC->Ellipse(PtInter1.m_X-5,PtInter1.m_Y+5,PtInter1.m_X+5,PtInter1.m_Y-5);
	pDC->Ellipse(PtInter2.m_X-5,PtInter2.m_Y+5,PtInter2.m_X+5,PtInter2.m_Y-5);
	pDC->Ellipse(PtCenterEjeRadicalx-5,PtCenterEjeRadicaly+5,PtCenterEjeRadicalx+5,PtCenterEjeRadicaly-5);	
*/	
	double nDist1= sqrt( (double)((m_PtLastPoint.m_X - PtInter1.m_X) * (m_PtLastPoint.m_X - PtInter1.m_X)) + ((m_PtLastPoint.m_Y - PtInter1.m_Y) * (m_PtLastPoint.m_Y - PtInter1.m_Y)) );
	double nDist2= sqrt( (double)((m_PtLastPoint.m_X - PtInter2.m_X) * (m_PtLastPoint.m_X - PtInter2.m_X)) + ((m_PtLastPoint.m_Y - PtInter2.m_Y) * (m_PtLastPoint.m_Y - PtInter2.m_Y)) );

	if ( abs(nDist1) < abs(nDist2) )
	{
		 m_PtLastPoint.m_X = PtInter1.m_X;
		 m_PtLastPoint.m_Y = PtInter1.m_Y;
	}
	else 
	{
		 m_PtLastPoint.m_X = PtInter2.m_X;
		 m_PtLastPoint.m_Y = PtInter2.m_Y;
	}

	ReleaseDC(pDC);

	return TRUE;
}

